;    .
; windlg.asm
;defs32.inc

WM_INITDIALOG		equ	110h
WM_CLOSE		equ	10h
WM_COMMAND		equ	111h
WM_CHAR			equ	102h

WM_COPY equ 301h
WM_PASTE equ 302h

WM_SETTEXT		equ	12
WM_GETTEXT equ 13

WM_SETICON equ 80h
RECT	struc
	l	dd	?
	t	dd	?
	r	dd	?
	b	dd	?
RECT	ends

;---------------------------------------------include DEFS32.INC
	includelib	import32.lib
	extrn	ExitProcess:proc
	extrn	GetModuleHandleA:proc
	extrn	SendMessageW:proc
	extrn	lstrlenW:proc

	extrn	DialogBoxParamW:proc

	extrn	GetDlgItem:proc
	extrn	GetDlgItemInt:proc
	extrn	SetDlgItemInt:proc

	extrn	GlobalAlloc:near
	extrn	GlobalFree:near

	extrn GetWindowRect:proc
	extrn SetWindowPos:proc
	extrn GetDesktopWindow:proc
	extrn LoadIconA:proc
;---------------------------------------------include APICALLS.INC


	.386
	.model flat,stdcall

	.data?
dtr RECT<?,?,?,?>
dlr RECT<?,?,?,?>

hinst dd ?

	.data
ww: dd 0
	.code
_start:
	xor	ebx,ebx
	call	GetModuleHandleA,ebx
	mov hinst,eax
	call	DialogBoxParamW,eax,300,ebx,offset	dialog_proc,ebx

failure:
	call	ExitProcess,ebx

dialog_proc	proc	near
	push	ebp
	mov	ebp,esp
dp_hWnd		equ	dword ptr [ebp+08h] ; DIALOG_id
dp_uMsg		equ	dword ptr [ebp+0Ch] ; message #
dp_wParam	equ	dword ptr [ebp+10h] ; 1st param.
dp_lParam	equ	dword ptr [ebp+14h] ; 2nd param.

;WM_PASTE,0,0
	mov	ecx,dp_hWnd
	mov	eax,dp_uMsg
;	mov	hwnd_dlg,ecx
	cmp	eax,WM_INITDIALOG
	jne	not_initdialog
;initialisation dialogs
	call GetDesktopWindow
	call GetWindowRect,eax,offset dtr
	call GetWindowRect,dp_hWnd,offset dlr
	mov eax,dtr.r
	sub eax,dlr.r
	shr eax,1
	mov ecx,dtr.b
	sub ecx,dlr.b
	shr ecx,1
HWND_TOP equ 0
SWP_NOSIZE equ 1
	call SetWindowPos,dp_hWnd,HWND_TOP,eax,ecx,0,0,SWP_NOSIZE
ICON_SMALL equ 0
	call LoadIconA,hinst,400
	call SendMessageW,dp_hWnd,WM_SETICON, ICON_SMALL,eax

	call GetDlgItem,dp_hWnd,301
	call SendMessageW,eax,WM_SETTEXT,0,offset t_text
	jmp	not_exit
not_initdialog:
	cmp	eax,WM_CLOSE
	jne	not_close

close_dlg:
	jmp failure;;call	EndDialog,ecx,0
not_close:
	cmp	eax,WM_COMMAND
	jne	not_command
	mov	eax,dp_wParam
	cmp	eax,2
	je	close_dlg

EN_UPDATE equ 400h
	cmp	ax,301;   - 
	jne	not_exit

	shr	eax,10h
	cmp	eax,EN_UPDATE
    je process_field
	jmp	not_exit

process_field:
GMEM_FIXED equ 0h
GMEM_ZEROINIT equ 40h
WM_GETTEXTLENGTH equ 14

	push esi
	push edi

	call GetDlgItem,dp_hWnd,301
	call SendMessageW,eax,WM_GETTEXTLENGTH,0,0
	inc eax
	add eax,eax

	push eax
	push eax
	call	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax
	mov esi,eax

	pop eax
	call	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax
	mov edi,eax

	call GetDlgItem,dp_hWnd,301
	pop ecx
	call SendMessageW,eax,WM_GETTEXT,ecx,esi

    call lstrlenW,esi
    or eax,eax
    je stop
    mov ecx,eax

    push esi
    push edi

    add eax,eax
    add edi,eax

	dec edi
	dec edi

reverse_lp:;12345
	mov ax,[esi]
	inc esi
	inc esi
	mov [edi],ax
	dec edi
	dec edi
	loop reverse_lp
	pop edi
	pop esi

	call GetDlgItem,dp_hWnd,302
	call SendMessageW,eax,WM_SETTEXT,0,edi

stop:
;-------------------------end program
	call GlobalFree,esi
	call GlobalFree,edi

	pop edi
	pop esi
 jmp not_exit;end_proc
;------------------------------------------------------------
not_exit:
	xor	eax,eax
	inc	eax
	leave
	ret	16
not_command:
	xor	eax,eax
	leave
	ret	16
dialog_proc	endp
t_text:
 DB 112,000,111,000,117,000,235,000
 DB 116,000,032,000,050,000,046,000
 DB 048,000,058,000,032,000,252,000
 DB 110,000,105,000,099,000,248,000
 DB 100,000,101,000,032,000,056,004
 DB 111,000,119,000,032,000,072,004
 DB 081,001,114,000,107,000,115,000
 DB 032,000,105,000,110,000,032,000
 DB 116,000,104,000,101,000,032,000
 DB 195,003,110,000,101,000,108,000
 DB 105,000,174,003,101,000,114,000
 dw 0
end	_start
